package com.chinaitop.depot.intelligent.basicdata.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TWarningThresholdExample {
    /**
     * t_warning_threshold
     */
    protected String orderByClause;

    /**
     * t_warning_threshold
     */
    protected boolean distinct;

    /**
     * t_warning_threshold
     */
    protected List<Criteria> oredCriteria;

    public TWarningThresholdExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_warning_threshold 2019-03-22
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andWModuleIsNull() {
            addCriterion("w_module is null");
            return (Criteria) this;
        }

        public Criteria andWModuleIsNotNull() {
            addCriterion("w_module is not null");
            return (Criteria) this;
        }

        public Criteria andWModuleEqualTo(String value) {
            addCriterion("w_module =", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotEqualTo(String value) {
            addCriterion("w_module <>", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleGreaterThan(String value) {
            addCriterion("w_module >", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleGreaterThanOrEqualTo(String value) {
            addCriterion("w_module >=", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleLessThan(String value) {
            addCriterion("w_module <", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleLessThanOrEqualTo(String value) {
            addCriterion("w_module <=", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleLike(String value) {
            addCriterion("w_module like", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotLike(String value) {
            addCriterion("w_module not like", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleIn(List<String> values) {
            addCriterion("w_module in", values, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotIn(List<String> values) {
            addCriterion("w_module not in", values, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleBetween(String value1, String value2) {
            addCriterion("w_module between", value1, value2, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotBetween(String value1, String value2) {
            addCriterion("w_module not between", value1, value2, "wModule");
            return (Criteria) this;
        }

        public Criteria andWNameIsNull() {
            addCriterion("w_name is null");
            return (Criteria) this;
        }

        public Criteria andWNameIsNotNull() {
            addCriterion("w_name is not null");
            return (Criteria) this;
        }

        public Criteria andWNameEqualTo(String value) {
            addCriterion("w_name =", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotEqualTo(String value) {
            addCriterion("w_name <>", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameGreaterThan(String value) {
            addCriterion("w_name >", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameGreaterThanOrEqualTo(String value) {
            addCriterion("w_name >=", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameLessThan(String value) {
            addCriterion("w_name <", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameLessThanOrEqualTo(String value) {
            addCriterion("w_name <=", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameLike(String value) {
            addCriterion("w_name like", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotLike(String value) {
            addCriterion("w_name not like", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameIn(List<String> values) {
            addCriterion("w_name in", values, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotIn(List<String> values) {
            addCriterion("w_name not in", values, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameBetween(String value1, String value2) {
            addCriterion("w_name between", value1, value2, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotBetween(String value1, String value2) {
            addCriterion("w_name not between", value1, value2, "wName");
            return (Criteria) this;
        }

        public Criteria andWStateIsNull() {
            addCriterion("w_state is null");
            return (Criteria) this;
        }

        public Criteria andWStateIsNotNull() {
            addCriterion("w_state is not null");
            return (Criteria) this;
        }

        public Criteria andWStateEqualTo(Integer value) {
            addCriterion("w_state =", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateNotEqualTo(Integer value) {
            addCriterion("w_state <>", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateGreaterThan(Integer value) {
            addCriterion("w_state >", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateGreaterThanOrEqualTo(Integer value) {
            addCriterion("w_state >=", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateLessThan(Integer value) {
            addCriterion("w_state <", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateLessThanOrEqualTo(Integer value) {
            addCriterion("w_state <=", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateIn(List<Integer> values) {
            addCriterion("w_state in", values, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateNotIn(List<Integer> values) {
            addCriterion("w_state not in", values, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateBetween(Integer value1, Integer value2) {
            addCriterion("w_state between", value1, value2, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateNotBetween(Integer value1, Integer value2) {
            addCriterion("w_state not between", value1, value2, "wState");
            return (Criteria) this;
        }

        public Criteria andThresholdIsNull() {
            addCriterion("threshold is null");
            return (Criteria) this;
        }

        public Criteria andThresholdIsNotNull() {
            addCriterion("threshold is not null");
            return (Criteria) this;
        }

        public Criteria andThresholdEqualTo(BigDecimal value) {
            addCriterion("threshold =", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdNotEqualTo(BigDecimal value) {
            addCriterion("threshold <>", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdGreaterThan(BigDecimal value) {
            addCriterion("threshold >", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("threshold >=", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdLessThan(BigDecimal value) {
            addCriterion("threshold <", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("threshold <=", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdIn(List<BigDecimal> values) {
            addCriterion("threshold in", values, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdNotIn(List<BigDecimal> values) {
            addCriterion("threshold not in", values, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("threshold between", value1, value2, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("threshold not between", value1, value2, "threshold");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonIsNull() {
            addCriterion("w_update_person is null");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonIsNotNull() {
            addCriterion("w_update_person is not null");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonEqualTo(String value) {
            addCriterion("w_update_person =", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonNotEqualTo(String value) {
            addCriterion("w_update_person <>", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonGreaterThan(String value) {
            addCriterion("w_update_person >", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonGreaterThanOrEqualTo(String value) {
            addCriterion("w_update_person >=", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonLessThan(String value) {
            addCriterion("w_update_person <", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonLessThanOrEqualTo(String value) {
            addCriterion("w_update_person <=", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonLike(String value) {
            addCriterion("w_update_person like", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonNotLike(String value) {
            addCriterion("w_update_person not like", value, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonIn(List<String> values) {
            addCriterion("w_update_person in", values, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonNotIn(List<String> values) {
            addCriterion("w_update_person not in", values, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonBetween(String value1, String value2) {
            addCriterion("w_update_person between", value1, value2, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdatePersonNotBetween(String value1, String value2) {
            addCriterion("w_update_person not between", value1, value2, "wUpdatePerson");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeIsNull() {
            addCriterion("w_update_time is null");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeIsNotNull() {
            addCriterion("w_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeEqualTo(Date value) {
            addCriterion("w_update_time =", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeNotEqualTo(Date value) {
            addCriterion("w_update_time <>", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeGreaterThan(Date value) {
            addCriterion("w_update_time >", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("w_update_time >=", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeLessThan(Date value) {
            addCriterion("w_update_time <", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("w_update_time <=", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeIn(List<Date> values) {
            addCriterion("w_update_time in", values, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeNotIn(List<Date> values) {
            addCriterion("w_update_time not in", values, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("w_update_time between", value1, value2, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("w_update_time not between", value1, value2, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andDelFlagIsNull() {
            addCriterion("del_flag is null");
            return (Criteria) this;
        }

        public Criteria andDelFlagIsNotNull() {
            addCriterion("del_flag is not null");
            return (Criteria) this;
        }

        public Criteria andDelFlagEqualTo(Integer value) {
            addCriterion("del_flag =", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotEqualTo(Integer value) {
            addCriterion("del_flag <>", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagGreaterThan(Integer value) {
            addCriterion("del_flag >", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagGreaterThanOrEqualTo(Integer value) {
            addCriterion("del_flag >=", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagLessThan(Integer value) {
            addCriterion("del_flag <", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagLessThanOrEqualTo(Integer value) {
            addCriterion("del_flag <=", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagIn(List<Integer> values) {
            addCriterion("del_flag in", values, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotIn(List<Integer> values) {
            addCriterion("del_flag not in", values, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagBetween(Integer value1, Integer value2) {
            addCriterion("del_flag between", value1, value2, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotBetween(Integer value1, Integer value2) {
            addCriterion("del_flag not between", value1, value2, "delFlag");
            return (Criteria) this;
        }
    }

    /**
     * t_warning_threshold
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_warning_threshold 2019-03-22
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}